"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertExists_1 = __importDefault(require("./assertExists"));
const assertState_1 = __importDefault(require("./assertState"));
class BoundedChannel {
    limit;
    backlog = Array();
    sendWaiters = Array();
    recvWaiters = Array();
    constructor(limit) {
        this.limit = limit;
    }
    async send(v) {
        if (this.backlog.length >= this.limit) {
            await new Promise((resolve) => this.sendWaiters.push(resolve));
        }
        (0, assertState_1.default)(this.backlog.length < this.limit);
        this.backlog.push(v);
        this.recvWaiters.shift()?.();
    }
    async recv() {
        if (!this.backlog.length) {
            await new Promise((resolve) => this.recvWaiters.push(resolve));
        }
        this.sendWaiters.shift()?.();
        return (0, assertExists_1.default)(this.backlog.shift());
    }
}
exports.default = BoundedChannel;
