declare enum NodeType {
    DummyHead = 0,
    DummyTail = 1,
    List = 2
}
type DummyHeadNode<T> = {
    next: ValueNode<T> | DummyTailNode<T>;
    type: NodeType.DummyHead;
};
type DummyTailNode<T> = {
    prev: ValueNode<T> | DummyHeadNode<T>;
    type: NodeType.DummyTail;
};
declare class ValueNode<T> {
    private value;
    private detached;
    prev: ValueNode<T> | DummyHeadNode<T>;
    next: ValueNode<T> | DummyTailNode<T>;
    type: NodeType.List;
    constructor(prev: ValueNode<T> | DummyHeadNode<T>, next: ValueNode<T> | DummyTailNode<T>, value: T);
    detach(): void;
    getPrev(): ValueNode<T> | undefined;
    getNext(): ValueNode<T> | undefined;
    getValue(): T;
    setValue(v: T): void;
}
export declare type LinkedListNode<T> = Omit<ValueNode<T>, "prev" | "next" | "type">;
export declare const LinkedListNode: typeof ValueNode;
export default class LinkedList<T> implements Iterable<T> {
    private head;
    private tail;
    constructor();
    [Symbol.iterator](): Generator<T, void, unknown>;
    isEmpty(): boolean;
    append(val: T): ValueNode<T>;
    prepend(val: T): ValueNode<T>;
    getHead(): ValueNode<T> | undefined;
    getTail(): ValueNode<T> | undefined;
}
export {};
