export type PipelineComponent<I, O> = {
    costBuffer: number;
    concurrency: number;
    handler: (i: I) => Promise<O | undefined>;
    inputCost: (i: I) => number;
};
export default class Pipeline<LastOutput = unknown> {
    private readonly producer;
    private readonly components;
    private constructor();
    static from<O>(producer: () => Promise<O | undefined>): Pipeline<O>;
    then<O>(component: PipelineComponent<LastOutput, O>): Pipeline<O>;
    finally(final: (o: LastOutput) => Promise<void>): Promise<void>;
}
