"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const identity_1 = __importDefault(require("./identity"));
const nativeOrdering_1 = __importDefault(require("./nativeOrdering"));
exports.default = (array, needle, key = identity_1.default, comparator = nativeOrdering_1.default) => {
    let low = 0;
    let high = array.length - 1;
    while (low <= high) {
        const mid = Math.floor((low + high) / 2);
        const comparison = comparator(key(array[mid]), needle);
        if (comparison === 0) {
            return [true, mid];
        }
        else if (comparison < 0) {
            low = mid + 1;
        }
        else {
            high = mid - 1;
        }
    }
    return [false, low];
};
