"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertState_1 = __importDefault(require("./assertState"));
// Inspired by https://stackoverflow.com/a/10984975/6249022, is uniform.
// WARNING: If changing, ensure it remains uniform!
exports.default = (minInc, maxInc) => {
    const RAND_MAX = 2 ** 32;
    const n = maxInc - minInc + 1;
    (0, assertState_1.default)(n < RAND_MAX);
    let x;
    do {
        x = globalThis.crypto.getRandomValues(new Uint32Array(1))[0];
    } while (x >= RAND_MAX - (RAND_MAX % n));
    x %= n;
    return minInc + x;
};
