export type IsomorphicReadableStream<C> = {
    on(event: "data", listener: (chunk: C) => void): void;
    on(event: "error", listener: (err: Error) => void): void;
    on(event: "end", listener: () => void): void;
    [Symbol.asyncIterator](): AsyncIterator<C>;
} | {
    getReader(): {
        read(): Promise<{
            done: true;
            value?: C;
        } | {
            done: false;
            value: C;
        }>;
    };
};
declare const _default: <C>(stream: IsomorphicReadableStream<C>) => AsyncIterable<C>;
export default _default;
