"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (params) => {
    const pairs = Array();
    const handleScalar = (n, v) => {
        if (v == null) {
            return;
        }
        if (typeof v == "boolean") {
            if (!v) {
                return;
            }
            pairs.push([n]);
            return;
        }
        pairs.push([n, String(v)]);
    };
    for (const [n, v] of Object.entries(params)) {
        if (Array.isArray(v)) {
            v.forEach((v) => handleScalar(n, v));
        }
        else {
            handleScalar(n, v);
        }
    }
    return pairs.map((p) => p.map(encodeURIComponent).join("=")).join("&");
};
