"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertExists_1 = __importDefault(require("./assertExists"));
const assertState_1 = __importDefault(require("./assertState"));
async function* default_1(n, seq) {
    (0, assertState_1.default)(n > 0);
    const it = seq[Symbol.asyncIterator]();
    let done = false;
    const buffer = Array();
    let fetching = false;
    const maybeFetch = async () => {
        if (fetching) {
            return;
        }
        fetching = true;
        while (buffer.length < n && !done) {
            const next = it.next();
            buffer.push(next);
            const e = await next;
            if (e.done) {
                done = true;
            }
        }
        fetching = false;
    };
    while (true) {
        maybeFetch();
        if (done) {
            break;
        }
        const e = await (0, assertExists_1.default)(buffer.shift());
        if (e.done) {
            break;
        }
        yield e.value;
    }
}
exports.default = default_1;
